<?php
namespace Planejamento\Logic\PrevisaoConsumo;
use Geral\Entities\Lista;
use Geral\Logic\Exception;

/**
 * Created by JetBrains PhpStorm.
 * User: daniellepereira
 * Date: 12/03/12
 * Time: 15:48
 * To change this template use File | Settings | File Templates.
 */
class PrevisaoConsumoLogic{

    public $listaFiliais = '_';
    public $cdlista = '';
    protected $nome;
    protected $listaServi;

    private $paramsProcedure = array(
        'NRLISTAFILI'  => '',
        'DTINICIAL'    => '',
        'DTFINAL'      => '',
        'CDPRODUTOINI' => '',
        'CDPRODUTOFIN' => '',
        'PEACRESCIMO'  => '',
        'IDARREDOND'   => '',
        'CDOPERADOR'   => '',
        'DTHRCALCPC'   => ''
    );

    public function setParamsProcedure($params){
        $this->paramsProcedure['NRLISTAFILI']    = $params['NRLISTAFILI'];
        $this->paramsProcedure['DTINICIAL']    = $params['DTINICIAL'];
        $this->paramsProcedure['DTFINAL']      = $params['DTFINAL'];
        $this->paramsProcedure['CDPRODUTOINI'] = $params['CDPRODUTOINI'];
        $this->paramsProcedure['CDPRODUTOFIN'] = $params['CDPRODUTOFIN'];
        $this->paramsProcedure['PEACRESCIMO']  = $params['PEACRESCIMO'];
        $this->paramsProcedure['IDARREDOND']   = $params['IDARREDOND'];
        $this->paramsProcedure['CDOPERADOR']   = $params['CDOPERADOR'];
        $this->paramsProcedure['DTHRCALCPC']   = $params['DTHRCALCPC'];
    }

    public  function preencheTabelaLista($param_servico){
        $nrorg = $param_servico[0];
        $grupfili = $param_servico[1];
        $cdfilial = $param_servico[2];
        $grupserv = $param_servico[3];
        $cdservfili = $param_servico[4];
        $sql = $this->sql_retornaServicos($nrorg, $grupfili, $cdfilial, $grupserv, $cdservfili);
        try {
            $registro_servicos = \Setforms2\Runtime\Connection::getInstance()->fetchAll($sql);
            $var_filiais = '';
            $this->listaServi = Lista::novoCodigo();
            for ($i = 0; $i < count($registro_servicos); $i++) {
                $row = $registro_servicos[$i];
                Lista::insere($this->listaServi, $row['CDFILIAL'].$row['CDSERVFILI'], $nrorg);
                if ($var_filiais !== $row['CDFILIAL'])  {
                    $this->listaFiliais .= $row['CDFILIAL'].'_';
                }
                $var_filiais = $row['CDFILIAL'];
                $this->cdlista = $row['CDFILIAL'].$row['CDSERVFILI'];
            }

            $this->cdlista = $this->listaServi;
        } catch (\Setforms2\Shared\Connection\Exception\LimitRowsExceededException $e) {
            return 'msg_excede_numero_300registro';
        }
    }

    public function executaProcedure() {
        $parametros = array();
//        $this->nome = 'SF_PREV_CONS_LISTA';
        $this->nome = 'PREV_CONS_LISTA';
        foreach ($this->paramsProcedure as $key => $value){
            if (is_array($value) === false) {
                $parametros[$key] =  array('value' => $value);
            } else {
                $parametros[$key] = $value;
            }
            //$this->addParametro($key, $value);
        }

        try{
            return tk_call_procedure($this->nome, $parametros);
        }
        catch (Exception $e){
            tk_warning($e->getMessage());
        }
    }

    public function getParamTabelaLista(){
        $param_lista = array(
            'LISTASERV' => $this->listaServi,
            'LISTAFILI' => $this->listaFiliais,
            'CDLISTA'   => $this->cdlista
        );
        return $param_lista;
    }

    public function excluiRegistroLista($nrlista){
        Lista::deleta($nrlista);
    }

    public function sql_retornaServicos($nrorg, $grupfili, $cdfilial, $grupserv, $cdservfili){
        //Traz servicos que pertencem a um grupo de servicos.
        $where = '';
        if (!empty($grupserv)) {
            $where .= ' AND SERVICO.CDGRUPSERV = '.$grupserv.'';
        }
        if (!empty($cdservfili)) {
            //$where .= ' AND SERVICO.CDSERVFILI = '.$cdservfili.'';

            $all = "'T'";
            $where .= ' AND ((INSTR('."'".$cdservfili."'".', SERVICO.CDSERVFILI) <> 0) OR ('."'".$cdservfili."'".' = '.$all.'))';
        }

        //Traz servicos das filiais que pertencem a um agrupamento de filiais.
        $selectFilial = '';
        if (!empty($grupfili) && empty($cdfilial)){
            $selectFilial = '(SELECT F.CDFILIAL, F.NMFILIAL, F.NRORG
                                FROM FILIAL F, FILGRUPFILI G
                               WHERE G.NRORG = '.$nrorg.'
                                 AND G.CDGRUPFILI = '.$grupfili.'
                                 AND F.CDFILIAL = G.CDFILIAL
                                 AND F.NRORG = G.NRORG) FILIAL';
        }
        //Traz servicos da filial selecionada
        if (!empty($cdfilial)) {
            $selectFilial = 'FILIAL';
            //$where .= ' AND FILIAL.CDFILIAL = '.$cdfilial.'';
            $all = "'T'";
            $where .= ' AND ((INSTR('."'".$cdfilial."'".', FILIAL.CDFILIAL) <> 0) OR ('."'".$cdfilial."'".' = '.$all.'))';
        }
        //Traz servicos de todas as filiais
        if (empty($grupfili) && empty($cdfilial)) {
            $selectFilial = 'FILIAL';
        }

        $sql = 'SELECT
                SERVICO.CDFILIAL,
                SERVICO.CDSERVFILI,
                SERVICO.NMSERVICO,
                FILIAL.NMFILIAL,
                SERVICO.NRORG,
                SERVICO.CDGRUPSERV
                FROM
                   SERVICO,
                   '.$selectFilial.' 
                WHERE SERVICO.NRORG = '.$nrorg.' 
                '.$where.' 
                  AND SERVICO.CDFILIAL = FILIAL.CDFILIAL
                  AND SERVICO.NRORG = FILIAL.NRORG
                  AND SERVICO.IDSERVATIV = \'S\'
                ORDER BY
                   SERVICO.CDFILIAL,
                   SERVICO.CDSERVFILI';
        return $sql;
    }

    //----------------------------------------------------------------------//
    //STRING SELECT USADO NOS SEARCHS PARA FILIAL, SERVICO E GRUPO DE PRODUTO
    //----------------------------------------------------------------------//

    public static function sql_retornaFiliaisSearch(){
        return 'SELECT FILIAL.CDFILIAL,
                       FILIAL.NMFILIAL,
                       FILIAL.NRORG,
                       FILGRUPFILI.CDGRUPFILI,
                       REGIAO.CDREGIAO
                FROM FILIAL
                LEFT JOIN FILGRUPFILI
                  ON FILIAL.NRORG    = FILGRUPFILI.NRORG
                 AND FILIAL.CDFILIAL = FILGRUPFILI.CDFILIAL
                LEFT JOIN REGIAO
                  ON FILIAL.CDREGIAO  = REGIAO.CDREGIAO
                 AND FILIAL.NRORG    = REGIAO.NRORG
            ORDER BY NMFILIAL';
    }

    public static function sql_retornaServicosSearch($grupfili, $cdfilial = null, $grupoServ = null) {
        if (empty($grupoServ) === false) $where = "AND SERVICO.CDGRUPSERV = '$grupoServ'";


        if (!empty($grupfili)) {
            return 'SELECT SERVICO.CDFILIAL,
                      SERVICO.CDSERVFILI,
                      SERVICO.NMSERVICO,
                      SERVICO.NRORG,
                      SERVICO.CDGRUPSERV,
                      F.NMFILIAL,
                      G.CDGRUPFILI
                    FROM SERVICO,
                      FILIAL F,
                      FILGRUPFILI G
                   WHERE F.CDFILIAL = SERVICO.CDFILIAL
                     AND F.CDFILIAL = '.$cdfilial.'
                     AND F.NRORG = SERVICO.NRORG
                     AND F.NRORG = G.NRORG
                     AND F.CDFILIAL = G.CDFILIAL
                     AND WHERE_PLACEHOLDER
                     AND FILTER_PLACEHOLDER
                     '.$where.'
                ORDER BY F.NMFILIAL, SERVICO.CDSERVFILI';
        }


        return 'SELECT SERVICO.CDFILIAL,
                  SERVICO.CDSERVFILI,
                  SERVICO.NMSERVICO,
                  SERVICO.NRORG,
                  SERVICO.CDGRUPSERV,
                  F.NMFILIAL,
                  NULL CDGRUPFILI
                FROM SERVICO,
                  FILIAL F
               WHERE F.CDFILIAL = SERVICO.CDFILIAL
                 AND F.CDFILIAL = '.$cdfilial.'
                 AND F.NRORG = SERVICO.NRORG
                 '.$where.'
                 AND WHERE_PLACEHOLDER
                 AND FILTER_PLACEHOLDER
            ORDER BY F.NMFILIAL, SERVICO.CDSERVFILI';
    }


    public static function sql_retornaSubGrupProdutoSearch($nrorg, $cdfilial){
        $sql = 'SELECT SUBGRUPPROD.CDSUBGRPROD, SUBGRUPPROD.NMSUBGRPROD, SUBGRUPPROD.CDGRUPPROD,
               NVL(F.CDFILCENTCMP,F.CDFILIAL) CDFILCENTCMP, F.NRORG
        FROM SUBGRPRODFIL SF, SUBGRUPPROD, PARASUPRI P, FILIAL F
        WHERE
           F.NRORG = '.$nrorg.' AND
           F.CDFILIAL = '.$cdfilial.' AND
           P.CDFILIAL = NVL(F.CDFILCENTCMP,F.CDFILIAL) AND
           P.NRORG = F.NRORG AND
           SF.CDGRUPPROD = P.CDGRUPPROD AND
           SF.NRORG = P.NRORG AND
           SF.CDFILISUBGR = \'P\' AND
           SF.CDGRUPPROD = SUBGRUPPROD.CDGRUPPROD AND
           SF.CDSUBGRPROD = SUBGRUPPROD.CDSUBGRPROD AND
           SF.NRORG = SUBGRUPPROD.NRORG
        UNION
        SELECT SUBGRUPPROD.CDSUBGRPROD, SUBGRUPPROD.NMSUBGRPROD, SUBGRUPPROD.CDGRUPPROD,
               NVL(F.CDFILCENTCMP,F.CDFILIAL) CDFILCENTCMP, F.NRORG
        FROM SUBGRPRODFIL SF, SUBGRUPPROD, PARASUPRI P, FILIAL F
        WHERE
           F.NRORG = '.$nrorg.' AND
           F.CDFILIAL = '.$cdfilial.' AND
           P.CDFILIAL = NVL(F.CDFILCENTCMP,F.CDFILIAL) AND
           P.NRORG = F.NRORG AND
           SF.CDGRUPPROD = P.CDGRUPPROD AND
           SF.NRORG = P.NRORG AND
           SF.CDFILISUBGR = F.CDFILCENTCMP AND
           SF.NRORG = F.NRORG AND
           SF.CDGRUPPROD = SUBGRUPPROD.CDGRUPPROD AND
           SF.CDSUBGRPROD = SUBGRUPPROD.CDSUBGRPROD AND
           SF.NRORG = SUBGRUPPROD.NRORG AND
           WHERE_PLACEHOLDER AND
           FILTER_PLACEHOLDER
        ORDER BY CDGRUPPROD, CDSUBGRPROD';
        return $sql;
    }
}
